package {
import flash.display.DisplayObject;
import flash.display.StageAlign;
import flash.display.StageDisplayState;
import flash.display.StageScaleMode;
import flash.events.FullScreenEvent;
import flash.text.TextFormat;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flash.events.MouseEvent;
import flash.display.SimpleButton;
import flash.display.Sprite;
import flash.net.NetConnection;
import flash.net.NetStream;
//import flash.events.AsyncErrorEvent;
import flash.events.NetStatusEvent;
import flash.media.Video;
import flash.utils.Timer;
import flash.events.TimerEvent;

public class ExampleURLVideo extends Sprite {
  protected var start:Boolean;
  protected var pause:Boolean;
  protected var scale:Number;
  protected var nc:NetConnection;
  protected var ns:NetStream;
  protected var tm:Timer;
  protected var items:Array;
  protected var fs:Array;

  public function ExampleURLVideo():void {
    super();
    var s:Number = 16.0;
    fs = [
      new TextFormat("Courier", s, 0x000000),
      new TextFormat("Webdings", s, 0x000000),
    ];
    items = [
      new SimpleButton(),
      new SimpleButton(new Label("\x37", fs[1], 2, 0),
                       new Label("\x37", fs[1], 2, 1),
                       new Label("\x37", fs[1], 2, 2),
                       new Label("\x37", fs[1], 2)),
      new SimpleButton(new Label("\x38", fs[1], 2, 0),
                       new Label("\x38", fs[1], 2, 1),
                       new Label("\x38", fs[1], 2, 2),
                       new Label("\x38", fs[1], 2)),
      new Label("URL",	fs[0], 0, 0, [s*2, s]),
      new Label("",	fs[0], 1, 0, [s*24, s]),
      new SimpleButton(),
      new SimpleButton(new Label("\x4c", fs[1], 2, 0),
                       new Label("\x4c", fs[1], 2, 1),
                       new Label("\x4c", fs[1], 2, 2),
                       new Label("\x4c", fs[1], 2)),
      new SimpleButton(new Label("\x31", fs[1], 2, 0),
                       new Label("\x31", fs[1], 2, 1),
                       new Label("\x31", fs[1], 2, 2),
                       new Label("\x31", fs[1], 2)),
      new Video(),
      new TextField(),
    ];
    start = pause = false;
    scale = 1;
    transition_pause();
    transition_start();
    transition();
    items[0].addEventListener(MouseEvent.CLICK, pbPause);
    items[1].addEventListener(MouseEvent.CLICK, pbRew);
    items[2].addEventListener(MouseEvent.CLICK, pbFF);
    items[5].addEventListener(MouseEvent.CLICK, pbStart);
    items[6].addEventListener(MouseEvent.CLICK, pbScaleVideo);
    items[7].addEventListener(MouseEvent.CLICK, pbFullScreen);
    items[9].autoSize = TextFieldAutoSize.LEFT;
    items[0].x = items[0].y = 4;
    layouts(0, [items[0], items[1], items[2], items[3], items[4], items[5], items[6], items[7]]);
    layouts(1, [items[0], items[8], items[9]]);
    for each (var item:DisplayObject in items)
      addChild(item);
    nc = new NetConnection();
    nc.connect(null);
    ns = new NetStream(nc);
    //ns.addEventListener(AsyncErrorEvent.ASYNC_ERROR, asyncErrorHandler);
    ns.addEventListener(NetStatusEvent.NET_STATUS, statusHandler);
    ns.client = new NetStreamClient();
    items[8].attachNetStream(ns);
    items[8].smoothing = true;
    tm = new Timer(1000, 0);
    tm.addEventListener(TimerEvent.TIMER, timerHandler);
    stage.align = StageAlign.TOP_LEFT;
    stage.scaleMode = StageScaleMode.NO_SCALE;
  }
  protected function layouts(type:int, items:Array):void {
    var i:int;

    switch (type) {
    case 0:
      for (i=1; i<items.length; i++) {
        items[i].x = items[i-1].x + items[i-1].getRect(this).width + 4;
        items[i].y = items[i-1].y;
      }
      break;
    case 1:
      for (i=1; i<items.length; i++) {
        items[i].x = items[i-1].x;
        items[i].y = items[i-1].y + items[i-1].getRect(this).height + 4;
      }
      break;
    }
  }
  protected function transition_pause():void {
    items[0].upState      = new Label(pause?"\x34":"\x3b", fs[1], 2, 0);
    items[0].overState    = new Label(pause?"\x34":"\x3b", fs[1], 2, 1);
    items[0].downState    = new Label(pause?"\x34":"\x3b", fs[1], 2, 2);
    items[0].hitTestState = new Label(pause?"\x34":"\x3b", fs[1], 2);
  }
  protected function transition_start():void {
    items[5].upState      = new Label(start?"\xb7":"\xb8", fs[1], 2, 0);
    items[5].overState    = new Label(start?"\xb7":"\xb8", fs[1], 2, 1);
    items[5].downState    = new Label(start?"\xb7":"\xb8", fs[1], 2, 2);
    items[5].hitTestState = new Label(start?"\xb7":"\xb8", fs[1], 2);
  }
  protected function transition():void {
    items[9].text = "";
    if (ns != null) {
      items[9].text += "bytes: " + ns.bytesLoaded + "/" + ns.bytesTotal + "\n";
      items[9].text += "time: " + ns.time + "/" + ns.client.duration + "\n";
      if (items[8].videoWidth!=0 && items[8].videoHeight!=0 &&
          (items[8].width != items[8].videoWidth*scale ||
           items[8].height != items[8].videoHeight*scale)) {
        items[8].width = items[8].videoWidth*scale;
        items[8].height = items[8].videoHeight*scale;
        layouts(1, [items[0], items[8], items[9]]);
      }
    }
  }
  public function statusHandler(event:NetStatusEvent):void {
    switch (event.info.code) {
    case "NetStream.Buffer.Full":
    case "NetStream.Buffer.Empty":
      break;
    default:
      items[9].text += event.info.code + "\n";
      break;
    }
  }
  public function timerHandler(event:TimerEvent):void {
    transition();
  }
  public function pbStart(event:MouseEvent):void {
    if (!start) {
      if (items[4].tf.text != null) {
        ns.play(items[4].tf.text);
        start = true;
        tm.start();
        transition_start();
      }
    }
    else {
      ns.close();
      start = pause = false;
      tm.stop();
      transition_start();
      transition_pause();
    }
    transition();
  }
  public function pbPause(event:MouseEvent):void {
    if (start) {
      ns.togglePause();
      pause = !pause;
      transition_pause();
    }
  }
  public function pbRew(event:MouseEvent):void {
    if (start)
      ns.seek((ns.time>=10)?ns.time-10:0);
  }
  public function pbFF(event:MouseEvent):void {
    if (start)
      ns.seek(ns.time+10);
  }
  public function pbScaleVideo(event:MouseEvent):void {
    switch (scale) {
    case .5: scale = 1; break;
    case 1: scale = 1.5; break;
    case 1.5: scale = 2; break;
    case 2:
      scale = Math.min((stage.stageWidth-(items[8].x+4))/items[8].videoWidth,
                       (stage.stageHeight-(items[8].y+4))/items[8].videoHeight);
      break;
    default: scale = .5; break;
    }
    transition();
  }
  public function pbFullScreen(event:MouseEvent):void {
    stage.displayState = (stage.displayState==StageDisplayState.FULL_SCREEN)?
      StageDisplayState.NORMAL:StageDisplayState.FULL_SCREEN;
    scale = (stage.displayState==StageDisplayState.FULL_SCREEN)?2:.5;
    pbScaleVideo(event);
  }
}

}
