package {
import flash.text.TextFieldType;
import flash.text.TextFormat;
import flash.display.Sprite;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;

public class Label extends Sprite {
  public var tf:TextField;
  public var bg:Sprite;
  protected var type:int;
  protected var state:int;
  protected var size:Array;
  [Embed(source="lib/webdings.ttf",fontName="Webdings",mimeType='application/x-font')]
  public var Webdings:Class;
  [Embed(source="lib/wingdings.ttf",fontName="Wingdings",mimeType='application/x-font')]
  public var Wingdings:Class;
  [Embed(source="lib/wingdings_2.ttf",fontName="Wingdings 2",mimeType='application/x-font')]
  public var Wingdings2:Class;
  [Embed(source="lib/wingdings_3.ttf",fontName="Wingdings 3",mimeType='application/x-font')]
  public var Wingdings3:Class;

  public function Label(label:String, tfm:TextFormat=null, type:*=null, state:*=null, size:Array=null):void {
    super();
    tf = new TextField();
    if (tfm != null)
      tf.defaultTextFormat = tfm;
    this.type = type;
    this.state = state;
    if (size != null) {
      this.size = size;
      tf.width = size[0] + 2*2;
      tf.height = size[1] + 2*2;
    }
    else
      tf.autoSize = TextFieldAutoSize.LEFT;
    tf.htmlText = label;
    switch (type) {
      case 1: {
        tf.type = TextFieldType.INPUT;
      } break;
    }
    switch (tfm.font) {
    case "Webdings":
    case "Wingdings":
    case "Wingdings 2":
    case "Wingdings 3":
      tf.embedFonts = true;
      break;
    default:
      tf.embedFonts = false;
      break;
    }
    bg = new Sprite();
    bgDraw();
    addChild(bg);
    addChild(tf);
  }
  public function bgDraw():void {
    var m:Number = tf.defaultTextFormat.leftMargin + tf.defaultTextFormat.rightMargin;
    var d:Number;
    var size:Array = (this.size != null) ? this.size : [tf.textWidth, tf.textHeight];
    var w:Number;

    switch(state) {
    case 2:case 3:	d = 2.0; break;
    default:		d = 4.0; break;
    }
    x = y = 4 - d;
    bg.graphics.clear();
    switch (type) {
    case 0: {
        switch(state) {
	case 1:		w = 2.0; break;
	default:	w = 1.0; break;
	}
        bg.graphics.lineStyle(0, 0xCCCCCC);
        bg.graphics.beginFill(0xCCCCCC);
        bg.graphics.drawRoundRect(d, d, size[0] + m + 2*2, size[1] + 2*2, 2*4);
        bg.graphics.lineStyle(w, 0xFFFFFF);
        bg.graphics.beginFill(0xFFFFFF);
        bg.graphics.drawRoundRect(0, 0, size[0] + m + 2*2, size[1] + 2*2, 2*4);
        bg.graphics.endFill();
      } break;
    case 1: {
        switch(state) {
	case 1:		w = 2.0; break;
	default:	w = 1.0; break;
	}
        bg.graphics.lineStyle(0, 0xCCCCCC);
        bg.graphics.beginFill(0xCCCCCC);
        bg.graphics.drawRect(d, d, size[0] + m + 2*2, size[1] + 2*2);
        bg.graphics.lineStyle(w, 0x000000);
        bg.graphics.beginFill(0xFFFFFF);
        bg.graphics.drawRect(0, 0, size[0] + m + 2*2, size[1] + 2*2);
        bg.graphics.endFill();
      } break;
    default: {
        switch(state) {
	case 1:		w = 4.0; break;
	default:	w = 2.0; break;
	}
        bg.graphics.lineStyle(0, 0xCCCCCC);
        bg.graphics.beginFill(0xCCCCCC);
        bg.graphics.drawRoundRect(d, d, size[0] + m + 2*2, size[1] + 2*2, 2*4);
        bg.graphics.lineStyle(w, 0x000000);
        bg.graphics.beginFill(0xFFFFFF);
        bg.graphics.drawRoundRect(0, 0, size[0] + m + 2*2, size[1] + 2*2, 2*4);
        bg.graphics.endFill();
      } break;
    }
  }
  public function setLabel(label:String):void {
    tf.htmlText = label;
    bgDraw();
  }
}

}
